package com.virtual.plat.server.rs.warnmanage;

import com.virtual.common.AppException;
import com.virtual.common.StringManager;
import com.virtual.plat.server.entity.QueryConfig;
import com.virtual.plat.server.entity.QueryResult;
import com.virtual.plat.server.entity.UserGroup;
import com.virtual.plat.server.rs.RestUtils;
import com.virtual.plat.server.rs.common.ValidateParams;
import com.virtual.plat.server.rs.entity.ListResult;
import com.virtual.plat.server.rs.user.func.RsUserMgr;
import com.virtual.plat.server.rs.warnmanage.entity.RsEventStrategy;
import com.virtual.plat.server.rs.warnmanage.entity.RsEventStrategyDomain;
import com.virtual.plat.server.rs.warnmanage.func.RsEventMgr;
import com.virtual.plat.server.user.UserMgr;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import javax.annotation.Resource;
import javax.annotation.security.RolesAllowed;
import javax.servlet.http.HttpServletRequest;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.core.Response.ResponseBuilder;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Service;

@Service
@Path("/warnManage")
@Consumes({"application/xml", "application/json"})
@Produces({"application/xml", "application/json"})
public class WarnManageResource {

   @Context
   private UriInfo uriInfo;
   @Resource
   private RsEventMgr rsEventMgr = null;
   @Context
   private SecurityContext sc;
   @Context
   private HttpServletRequest req;
   @Resource
   private UserMgr userMgr = null;
   @Resource
   private RsUserMgr rsuserMgr = null;
   private static Log log = LogFactory.getLog(WarnManageResource.class);
   private static StringManager sm = StringManager.getManager("com.virtual.plat.server.rs.common");


   @PUT
   @Path("/addUserWarnDomain")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response addUserWarnDomain(RsEventStrategyDomain var1) {
      if(var1 == null) {
         Object[] var2 = new Object[]{sm.getString("param.is.null")};
         throw new AppException(16, var2);
      } else {
         this.rsEventMgr.addUserWarnDomain(var1);
         return Response.ok().build();
      }
   }

   @PUT
   @Path("/deleteUserWarnDomain")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response deleteUserWarnDomain(RsEventStrategyDomain var1) {
      if(var1 == null) {
         Object[] var2 = new Object[]{sm.getString("param.is.null")};
         throw new AppException(16, var2);
      } else {
         this.rsEventMgr.deleteUserWarnDomain(var1);
         return Response.ok().build();
      }
   }

   @PUT
   @Path("/startUserWarnStrategy")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response startUserWarnStrategy(@QueryParam("userId") Long var1, @QueryParam("eventStrategyId") Long var2) {
      if(var2 == null) {
         RsEventStrategy var3;
         (var3 = new RsEventStrategy()).setUserId(var1);
         var3.setState(Integer.valueOf(1));
         this.rsEventMgr.addEventStrategy(var3);
      } else {
         this.rsEventMgr.startUserWarnStrategy(var2);
      }

      return Response.ok().build();
   }

   @PUT
   @Path("/stopUserWarnStrategy")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response stopUserWarnStrategy(@QueryParam("eventStrategyId") Long var1) {
      this.rsEventMgr.stopUserWarnStrategy(var1);
      return Response.ok().build();
   }

   @GET
   @Path("/userWarnInfos")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response userWarnInfos() {
      MultivaluedMap var1 = this.uriInfo.getQueryParameters();
      Long var2 = null;
      Long var3 = null;
      Integer var4 = null;
      Integer var5 = null;
      Integer var6 = null;
      Long var7 = null;
      String var8 = null;
      Iterator var9 = var1.keySet().iterator();

      while(var9.hasNext()) {
         String var10 = (String)var9.next();
         if("userId".equals(var10)) {
            var2 = ValidateParams.parseLong((String)var1.getFirst(var10), false, "user.id.value.error");
         } else if("vmId".equals(var10)) {
            var3 = ValidateParams.parseLong((String)var1.getFirst(var10), true, "vm.id.value.error");
         } else if("eventLevel".equals(var10)) {
            var4 = Integer.valueOf(ValidateParams.parseInt((String)var1.getFirst(var10), true, "eventLevel.value.error").intValue());
         } else if("offset".equals(var10)) {
            var5 = Integer.valueOf(ValidateParams.parseInt((String)var1.getFirst(var10), true, "offset.is.null").intValue());
         } else if("limit".equals(var10)) {
            var6 = Integer.valueOf(ValidateParams.parseInt((String)var1.getFirst(var10), true, "limit.is.null").intValue());
         } else if("catalogId".equals(var10)) {
            var7 = ValidateParams.parseLong((String)var1.getFirst(var10), true, "catalogId.value.null");
         } else if("domainTitle".equals(var10)) {
            var8 = (String)var1.getFirst(var10);
         }
      }

      ListResult var11;
      return Response.ok(var11 = this.rsEventMgr.queryUserWarnInfos(var2, var3, var4, var7, var5, var6, var8)).header("Total", Long.valueOf(var11.getSize())).build();
   }

   @GET
   @Path("/userEventStrategy")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsEventStrategy userEventStrategy(@QueryParam("userId") Long var1) {
      if(var1 == null) {
         Object[] var2 = new Object[]{sm.getString("user.id.is.null")};
         throw new AppException(16, var2);
      } else {
         return this.rsEventMgr.userEventStrategy(var1);
      }
   }

   @GET
   @Path("/unselectedDomains")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response unselectedWarningDomains() {
      MultivaluedMap var1;
      QueryConfig var2 = RestUtils.queryParamToQueryInfo(var1 = this.uriInfo.getQueryParameters());
      Long var3 = null;
      Iterator var4 = var1.keySet().iterator();

      while(var4.hasNext()) {
         String var5 = (String)var4.next();
         Long var6;
         if("orgId".equals(var5)) {
            var6 = ValidateParams.parseLong((String)var1.getFirst(var5), true, "org.id.value.error");
            var2.addRestriction(var5, var6);
         } else if("userId".equals(var5)) {
            var3 = var6 = ValidateParams.parseLong((String)var1.getFirst(var5), true, "user.id.value.error");
            var2.addRestriction(var5, var6);
            Set var8;
            if((var8 = this.userMgr.queryUserById(var6).getUserGroups()) != null && var8.size() > 0) {
               UserGroup var9 = (UserGroup)var8.iterator().next();
               var2.addRestriction("userGrpId", var9.getId());
            }
         }
      }

      List var7;
      if((var7 = this.rsuserMgr.queryUserVmList(var2)).size() <= 0) {
         return Response.ok(new ListResult()).build();
      } else {
         this.rsEventMgr.filterDomainWarning(var7, var3);
         return Response.ok(new ListResult(0L, (long)var7.size(), var7)).build();
      }
   }

   @GET
   @Path("/selectedDomains")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response selectedWarningDomains() {
      MultivaluedMap var1;
      QueryConfig var2 = RestUtils.queryParamToQueryInfo(var1 = this.uriInfo.getQueryParameters());
      Iterator var3 = var1.keySet().iterator();

      while(var3.hasNext()) {
         String var4 = (String)var3.next();
         Long var5;
         if("orgId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), true, "org.id.value.error");
            var2.addRestriction(var4, var5);
         } else if("userId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), true, "user.id.value.error");
            var2.addRestriction(var4, var5);
         } else if("eventStrategyId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), true, "eventStrategyId.value.null");
            var2.addRestriction(var4, var5);
         }
      }

      QueryResult var7;
      ResponseBuilder var8;
      if((var7 = this.rsEventMgr.eventStrategyDomainList(var2)) != null && var7.getData() != null && var7.getData().size() > 0) {
         List var6 = var7.getData();
         (var8 = Response.ok(new ListResult(var7.getOffset(), (long)var2.getLimit(), var6))).header("Total", Long.valueOf(var7.getTotalLength()));
         return var8.build();
      } else {
         (var8 = Response.ok(new ListResult())).header("Total", Integer.valueOf(0));
         return var8.build();
      }
   }

   public void checkRsEventStrategy(RsEventStrategy var1) {
      if(var1.getUserId() == null) {
         Object[] var2 = new Object[]{sm.getString("user.id.is.null")};
         throw new AppException(16, var2);
      }
   }

}
